Description

Zeitwerk needs to be able to check if a given class or module has an autoload defined for a certain constant name, that would be

autoload?(cname, false), similar to const_defined?(cname, false).

Associated revisions

Revision fb85a428605265a8fd449b0702a4dd88cb6f3b20 - 06/21/2019 08:28 AM - byroot (Jean Boussier)

Add an optional inherit argument to Module#autoload?

[Feature #15777]

Closes: https://github.com/ruby/ruby/pull/2173

Revision 5b7cc63d114fbca641ce2d93c7b3f2117e38af60 - 06/21/2019 08:28 AM - nobu (Nobuyoshi Nakada)

Turned recur into int [Feature #15777]

Revision fb85a428605265a8fd449b0702a4dd88cb6f3b20 - 06/21/2019 08:28 AM - byroot (Jean Boussier)

Add an optional inherit argument to Module#autoload?

[Feature #15777]

Closes: https://github.com/ruby/ruby/pull/2173

Revision 5b7cc63d114fbca641ce2d93c7b3f2117e38af60 - 06/21/2019 08:28 AM - nobu (Nobuyoshi Nakada)

Turned recur into int [Feature #15777]

Revision fb85a428 - 06/21/2019 08:28 AM - byroot (Jean Boussier)

Add an optional inherit argument to Module#autoload?

[Feature #15777]

Closes: https://github.com/ruby/ruby/pull/2173

Revision 5b7cc63d - 06/21/2019 08:28 AM - nobu (Nobuyoshi Nakada)

Turned recur into int [Feature #15777]

History

#1 - 04/20/2019 08:18 AM - fxn (Xavier Noria)

- Description updated

#2 - 05/07/2019 11:13 AM - byroot (Jean Boussier)

I made a patch for this feature: https://github.com/ruby/ruby/pull/2173

#3 - 06/13/2019 05:59 AM - nobu (Nobuyoshi Nakada)

Changing the signature of rb_autoload_p could break API compatibility.

I think we'll need another function for it.

Maybe rb_autoload_at_p like as rb_const_defined_at?

#4 - 06/19/2019 02:24 PM - byroot (Jean Boussier)

@nobu (Nobuyoshi Nakada) I edited the patch the way you suggested. Let me know if you desire further changes.
#5 - 06/20/2019 05:22 AM - nobu (Nobuyoshi Nakada)

Is it necessary to export rb_autoload_at_p?

Do you have the plan to use it in extension libraries?

#6 - 06/20/2019 06:49 AM - nobu (Nobuyoshi Nakada)

byroot (Jean Boussier) wrote:

Let me know if you desire further changes.

 Fix the bug first.

In rb_autoload_at_p, this condition is wrong.

-    while (!autoload_defined_p(mod, id)) {

+    while (RTEST(recur) && autoload_defined_p(mod, id)) {

 Leave it unchanged but return nil if not recur in that loop.

#7 - 06/20/2019 07:20 PM - byroot (Jean Boussier)

Is it necessary to export rb_autoload_at_p?

Do you have the plan to use it in extension libraries?

 No I have no such plan. I did so because it's defined in variable.c but called from load.c so without that declaration it won't compile:

load.c:1180:12: error: implicit declaration of function 'rb_autoload_at_p' is invalid in C99 [-Werror,-Wimplic

it-function-declaration]

    return rb_autoload_at_p(mod, id, recur);

 I'm quite a MRI & C beginner though, so if there is a better way to do it I'll gladly change it.

@Eregon (Benoit Daloze) told me which place to declare internal functions. It's now in internal.h

return nil if not recur in that loop.

 Done.

#8 - 06/21/2019 08:13 AM - Eregon (Benoit Daloze)

- Assignee set to nobu (Nobuyoshi Nakada)

The new patch looks fine to me.

@nobu (Nobuyoshi Nakada) I'll let you merge it since you did most of the review.

#9 - 06/21/2019 08:29 AM - byroot (Jean Boussier)

- Status changed from Open to Closed

Applied in changeset git|fb85a428605265a8fd449b0702a4dd88cb6f3b20.

Add an optional inherit argument to Module#autoload?

[Feature #15777]

Closes: https://github.com/ruby/ruby/pull/2173
